declare type ResponseTrack = {
    title: string;
    artist: string;
    link: string;
};
declare type SpotifyClientOptions = {
    clientId: string;
    clientSecret: string;
    refreshToken: string;
};
declare type CurrentlyPlayingOptions = {
    fallbackToLastPlayed?: boolean;
};
declare class SpotifyClient {
    private readonly clientId;
    private readonly clientSecret;
    private readonly refreshToken;
    constructor({ clientId, clientSecret, refreshToken }: SpotifyClientOptions);
    private _genAccesToken;
    getCurrentlyPlaying: ({ fallbackToLastPlayed }?: CurrentlyPlayingOptions) => Promise<{
        title: string;
        artist: string;
        link: string;
        isPlaying: boolean;
    } | null>;
    getLastPlayed: () => Promise<ResponseTrack>;
}

export { SpotifyClient };
